package com.zm.order.tool.server.engine;

import com.alibaba.fastjson.JSON;
import com.google.common.collect.Maps;
import com.zm.order.tool.server.constants.ImageEnum;
import org.springframework.util.CollectionUtils;

import java.util.*;

/**
 * qm-banner
 *
 * @author nianchang
 * @ClassName ParseEngine2
 * @date 2021/06/17 10:58 上午
 */
@SuppressWarnings("all")
public class ParseEngine2 {

    public static Map<String, Object> parse(Map<String, Object> BaseMap, Map<String, Object> dataMap, String elName) {
        String id = BaseMap.get("id") != null ? BaseMap.get("id").toString() : "";
        Integer marginTop = BaseMap.get("marginTop") != null ? Integer.valueOf(BaseMap.get("marginTop").toString()) : 0;
        Integer marginBottom = BaseMap.get("marginBottom") != null ? Integer.valueOf(BaseMap.get("marginBottom").toString()) : 0;

        Integer height = dataMap.get("bannerHeight") != null ? Integer.valueOf(dataMap.get("bannerHeight").toString()) : 0;
        String activeColor = dataMap.get("pointColor") != null ? dataMap.get("pointColor").toString() : "";
        Double inactiveOpacity = dataMap.get("pointColorOpacity") != null ? Double.valueOf(dataMap.get("pointColorOpacity").toString()) : 0.0;
        Integer bottomDistance = dataMap.get("pointBottom") != null ? Integer.valueOf(dataMap.get("pointBottom").toString()) : 0;

        List<Map> imgsList = new ArrayList<>();
        if (Objects.nonNull(dataMap.get("imgs"))) {
            List<Map> imgsList1 = JSON.parseArray(dataMap.get("imgs").toString(), Map.class);
            imgsList.addAll(imgsList1);
        }
        Map<String, Object> source = buildDataSource(elName, id, marginTop, marginBottom,
                imgsList, activeColor, inactiveOpacity, bottomDistance, height);
        return source;
    }

    private static Map<String, Object> buildDataSource(String elName, String id, Integer marginTop, Integer marginBottom,
                                                       List<Map> imgsList, String activeColor, Double inactiveOpacity,
                                                       Integer bottomDistance, Integer height) {
        Map<String, Object> data = new HashMap<>();
        data.put("elName", elName);
        data.put("title", "Banner");
        Map<String, Object> map = buildCommonStyleMap(marginTop, marginBottom, height);
        data.put("commonStyle", map);
        data.put("isFixed", false);
        data.put("propsValue", buildPropsValue(activeColor, inactiveOpacity, bottomDistance, imgsList));
        data.put("events", buildEvents());
        data.put("icon", "qimai-lunbo");
        data.put("id", id);
        String miniStyle = BuildStyle.build(map, elName);
        data.put("miniStyle", miniStyle);
        return data;
    }

    private static Map<String, Object> buildPropsValue(String activeColor, Double inactiveOpacity,
                                                       Integer bottomDistance, List<Map> imgsList) {
        Map<String, Object> propsValue = new HashMap<>();
        propsValue.put("points", buildPoints(activeColor, inactiveOpacity, bottomDistance));
        propsValue.put("imgs", buildImgs(imgsList));
        return propsValue;
    }

    private static List<Map<String, Object>> buildImgs(List<Map> imgsList) {
        List<Map<String, Object>> imgs = new ArrayList<>();
        if (!CollectionUtils.isEmpty(imgsList)) {
            for (Map<String, Object> map : imgsList) {
                Map<String, Object> imgsMap = new HashMap<>();
                String link = Objects.nonNull(map.get("link")) ? map.get("link").toString() : "";
                String linkText = Objects.nonNull(map.get("link_text")) ? map.get("link_text").toString() : "";
                ImageEnum imageEnum = ImageEnum.getValue(link);
                if (imageEnum != null) {
                    link = imageEnum.getNewValue();
                    linkText = imageEnum.getDesc();
                }
                imgsMap.put("link", link);
                imgsMap.put("linkType", Objects.nonNull(map.get("link_ty")) ? map.get("link_ty") : "");
                imgsMap.put("linkText", linkText);
                imgsMap.put("img", Objects.nonNull(map.get("img")) ? map.get("img") : "");
                imgsMap.put("extraData", Maps.newHashMap());
                imgs.add(imgsMap);
            }
        }
        return imgs;
    }
    
    private static Map<String, Object> buildPoints(String activeColor, Double inactiveOpacity, Integer bottomDistance) {
        Map<String, Object> points = new HashMap<>();
        points.put("bottomDistance", bottomDistance);
        points.put("inactiveOpacity", inactiveOpacity);
        points.put("activeColor", activeColor);
        return points;
    }

    private static Map<String, Object> buildEvents() {
        Map<String, Object> eventsMap = new HashMap<>();
        eventsMap.put("type", "");
        eventsMap.put("page", buildPage());
        eventsMap.put("phone", "");
        eventsMap.put("audioUrl", "");
        eventsMap.put("alipay", buildAliPay());
        eventsMap.put("map", buildMap());
        return eventsMap;
    }

    private static Map<String, Object> buildMap() {
        Map<String, Object> map = new HashMap<>();
        map.put("lng", "");
        map.put("lat", "");
        map.put("name", "");
        map.put("address", "");
        return map;
    }

    private static Map<String, Object> buildPage() {
        Map<String, Object> page = new HashMap<>();
        page.put("link", "");
        page.put("linkType", "");
        page.put("linkText", "");
        page.put("extraData", new HashMap<>());
        return page;
    }

    private static Map<String, Object> buildAliPay() {
        Map<String, Object> alipay = new HashMap<>();
        alipay.put("tntInstId", "");
        alipay.put("scene", "");
        return alipay;
    }

    private static List<Map<String, Object>> buildElements(String elName, String text) {
        List<Map<String, Object>> elements = new ArrayList<>();
        Map<String, Object> data = new HashMap<>();
        data.put("elName", elName);
        data.put("commonStyle", buildCommonStyle());
        data.put("propsValue", buildPropsValue1(text));
        // ???
        data.put("miniStyle", "");
        elements.add(data);
        return elements;
    }

    private static Map<String, Object> buildPropsValue1(String text) {
        Map<String, Object> propsValue = new HashMap<>();
        propsValue.put("text", text);
        return propsValue;
    }

    private static Map<String, Object> buildCommonStyle() {
        Map<String, Object> commonStyle = new HashMap<>();
        commonStyle.put("height", 40);
        commonStyle.put("fontSize", 16);
        commonStyle.put("fontWeight", 600);
        commonStyle.put("lineHeight", 40);
        commonStyle.put("paddingLeft", 10);
        commonStyle.put("paddingRight", 10);
        commonStyle.put("textAlign", "center");
        return commonStyle;
    }

    private static Map<String, Object> buildCommonStyleMap(Integer marginTop, Integer marginBottom, Integer height) {
        Map<String, Object> commonStyle = new HashMap<>();
        commonStyle.put("position", "");
        commonStyle.put("height", Objects.nonNull(height) ? height : 400);
        commonStyle.put("top", 0);
        commonStyle.put("left", 0);
        commonStyle.put("paddingTop", 0);
        commonStyle.put("paddingLeft", 0);
        commonStyle.put("paddingRight", 0);
        commonStyle.put("paddingBottom", marginBottom);
        commonStyle.put("marginTop", marginTop);
        commonStyle.put("marginLeft", 0);
        commonStyle.put("marginRight", 0);
        commonStyle.put("marginBottom", 0);
        commonStyle.put("borderWidth", 0);
        commonStyle.put("borderColor", "transparent");
        commonStyle.put("borderStyle", "solid");
        commonStyle.put("borderRadius", 0);
        commonStyle.put("boxShadow", "");
        commonStyle.put("fontSize", 14);
        commonStyle.put("fontWeight", 400);
        commonStyle.put("lineHeight", 24);
        commonStyle.put("letterSpacing", 0);
        commonStyle.put("textAlign", "left");
        commonStyle.put("color", "#333");
        commonStyle.put("backgroundColor", "");
        commonStyle.put("backgroundImage", "");
        commonStyle.put("backgroundSize", "contain");
        commonStyle.put("backgroundRepeat", "no-repeat");
        commonStyle.put("backgroundPosition", "center");
        commonStyle.put("opacity", 1);
        commonStyle.put("rotate", 0);
        commonStyle.put("zIndex", 1);
        return commonStyle;
    }
}
